#include <sys/farptr.h>
#include <go32.h>

char picture[ 320 * 200 ];

#define LEVEYS  320
#define KORKEUS 200
#define IN        1
#define OUT       0

inline void putpixel( short y, short x, unsigned char color )
{
    //      Tm toimii vain DJGPP:ss. Muuta jos osaat.    //

   _farpokeb( _dos_ds, 0xA0000 + (x * 320 + y), color );
}

char loadpic( unsigned char _nimi_[] )
{
    FILE *_INPUT_PCX;
    unsigned short w, h, p;
    short tavu, tavu2;

    _INPUT_PCX = fopen( _nimi_, "rb" );
    if ( !_INPUT_PCX )
        return( 1 );

    fseek( _INPUT_PCX, 8, SEEK_SET );

    w = fgetc( _INPUT_PCX ) + ( fgetc( _INPUT_PCX ) << 8 ) + 1;
    h = fgetc( _INPUT_PCX ) + ( fgetc( _INPUT_PCX ) << 8 ) + 1;

    fseek( _INPUT_PCX, 128, SEEK_SET );

    for( p = 0; p < w * h;)
    {
        tavu = fgetc( _INPUT_PCX );

        if( tavu > 192 )
        {
            tavu2 = fgetc( _INPUT_PCX );
            for( ; tavu > 192; tavu-- )
                picture[ p++ ] = tavu2;
        }
        else
        {
            picture[ p++ ] = tavu;
        }
    }
    fclose( _INPUT_PCX );
    return( 0 );
}

void putpic( void )
{
    unsigned short x, y, tmp = 0;
    for( y = 0; y < 200; y++ )
        for( x = 0; x < 320; x++ )
        {
            putpixel( x, y, picture[ tmp ] );
                tmp++;
        }
}

void nullpal( void )
{
    short c;

    outportb( 0x3C8, 0 );
    for( c = 0; c < 756; c++ )
        outportb( 0x03C9, 0 );
}

char fade( char kuva[], char in_out )
{
    unsigned short c, i;
    float paletti[ 256 * 3 ];
    float newpal[ 256 * 3 ];
    FILE *_INPUT_PCX;
    _INPUT_PCX = fopen( kuva, "rb" );

    if( !_INPUT_PCX )
        return( 1 );

    for( i = 0; i < 256 * 3; i++ )
        newpal[ i ] = 0;

    fseek( _INPUT_PCX, -768l, SEEK_END );

    for( c = 0; c < 256; c++ )
    {
        paletti[ c * 3 + 0 ] = fgetc( _INPUT_PCX ) / 4;
        paletti[ c * 3 + 1 ] = fgetc( _INPUT_PCX ) / 4;
        paletti[ c * 3 + 2 ] = fgetc( _INPUT_PCX ) / 4;

        if( in_out == OUT )
        {
            newpal[ c * 3 + 0 ] = paletti[ c * 3 + 0 ];
            newpal[ c * 3 + 1 ] = paletti[ c * 3 + 1 ];
            newpal[ c * 3 + 2 ] = paletti[ c * 3 + 2 ];
        }
    }

    fclose( _INPUT_PCX );

    outportb( 0x3C8, 0 );
    for( i = 0; i < 30; i++ )
    {
        for( c = 0; c < 256 * 3; c++ )
        {
            if( in_out == IN )
            {
                newpal[ c ] = newpal[ c ] + ( paletti[ c ] / 30 );
            }
            else
            {
                newpal[ c ] = newpal[ c ] + ( -paletti[ c ] / 30 );
            }

                outportb( 0x03C9, ( int ) newpal[ c ] );
        }
        delay( 15 );
    }

    return( 0 );
}

